#ifndef DIAMETROFERET_H
#define DIAMETROFERET_H
#include <QDebug>
#include <cmath>
#include <QRgb>
#include <QImage>
#include <QTextStream>
#include <QFile>
#include <QString>
#include <QPoint>
#include <QList>

class DiametroFeret
{
	private:
		
	public:
		QPoint positionPixel(int neighbour);
		int positionNeighbour(int position_image, int position_mask, int height_or_width);
		bool isObject(QImage &image, int x,int y);
		bool isBackground(QImage &image, int x,int y);
		void pixelsRegion(QImage &image, QList<QPoint> *contourRegion, bool updateMaxMin);
		QList<QPoint> pixelsRegion(QImage &image,QPoint positionInitial,bool updateMaxMin);
		int translation(int coordenada, int desplazamiento);
		QPoint translation(QPoint coordenada, QPoint desplazamiento);
		float distance( QPoint &point1,  QPoint &point2);
		QImage extractParticle(QList<QPoint> &particleList,QImage &image);
		float absValue(float number);
		QPoint finalLinePerperdicular( QPoint &point1,  QPoint &point2,  float m);
		QList<QPoint>  traceLineDiagonal(QImage &image, QPoint pointInitial, float tangent);
		bool limitedParticle(QImage & image, QPoint pointInitial, float tangent);
		void calcularValoresFeret(QImage &image);
		bool apply( QImage &imagenBinaria, QString nombreImagen);
		void saveFile(const QString & fileName);
		bool isCylindrical();
};

#endif //DIAMETROFERET_H
