/***********************************************************************/
/*                                                                     */
/*   Distancias.cpp                                                    */
/*                                                                     */
/*                                                                     */
/*   Author: Claudia Mazo                                              */
/*   Date: 26.09.13                                                    */
/*                                                                     */
/*   Copyright (c) 2013  Claudia Mazo - All rights reserved            */
/*                                                                     */
/*   This software is available for non-commercial use only. It must   */
/*   not be modified and distributed without prior permission of the   */
/*   author. The author is not responsible for implications from the   */
/*   use of this software.                                             */
/*                                                                     */
/***********************************************************************/

#include "Distancias.h"
#define PI 3.14159265

Distancias::Distancias(vector< list<Point> >& nucleus, vector< list<Point> >& regions, vector< list<Point> >& epiteliales)
{
	vector < Celula > mayores;
	mayorDistanciaCelulas(nucleus, regions, epiteliales, mayores);
	esPlana(mayores, regions);
}


//linea mas larga dentro de cada celula
void Distancias::mayorDistanciaCelulas(vector< list<Point> >& nucleus, vector< list<Point> > reg, vector< list<Point> >& bordeEpitelial, vector< Celula >& salida)
{
	int dist=0;
	//REP(bor, nucleus.size()-1) {
	FOREACH(nucl, nucleus) {
		int mayor=-999999999;
		Point pIni, pFin;
		
		if(esEpitelial(*nucl, reg)){
			bordeEpitelial.push_back(*nucl);
			FOREACH(p, *nucl){
				//FOREACH2(p2, nucleus[bor], *p++){
				list<Point>::iterator p2=p;
				p2++;
				for( ; p2!=nucl->end(); ++p2) {
					int dx = (p->x - p2->x),  dy = (p->y - p2->y);
					dist = dx*dx + dy*dy;
					if(dist>mayor){
						mayor=dist;
						pIni=*p;
						pFin=*p2;
					}
				}
			}
			salida.push_back(Celula(pIni,pFin));
        }
    }
	cerr<<"Cantidad CELULAS EPITELIALES "<<salida.size()<<endl;
}

//define si es EPITELIAL
bool Distancias::esEpitelial(list<Point>& nucleo, vector< list<Point> >& regiones)
{
	int dist=0;
	int minima=200;
	FOREACH(n, nucleo){
		FOREACH(reg, regiones){
			//assert(reg->size());
			FOREACH(p, *reg){
				int dx = (n->x - p->x),  dy = (n->y - p->y);
				dist = dx*dx + dy*dy;
				if(dist<=minima)
					return true;
			}
		}
	}
	return false;
}

//define si es plana o cilindrica
void Distancias::esPlana(vector< Celula >& ptosNucleos, vector< list<Point> > regiones)
{
	int dist=0;
	int parados=0;
	double result;
	int longitud, proyeccion;//////////////////////////////////////////////////////////
	list<Point> miRegion;//////////////////////////////////////////////////////////
	//int a, b, c;
	FOREACH(nucl, ptosNucleos) {
		Point pReg;
		int minima=1000000000;
		int minima2=1000000000;//////////////////////////////////////////////////////////
		//assert(regiones.size());
		FOREACH(reg, regiones){
			//assert(reg->size());
			FOREACH(p, *reg){
				int dx = (nucl->first.x - p->x),  dy = (nucl->first.y - p->y);
				dist = dx*dx + dy*dy;
				if(dist<minima){
					minima=dist;
					pReg=*p;
					miRegion=*reg;//////////////////////////////////////////////////////////
				}
			}
		}
		///////////////////////////////////////////////////////////////////////////////////////
		
		//cerr<<"punto "<<pReg.x<<" "<<pReg.y<<endl;
		//cin.get();
		Point pReg2;
		FOREACH(p, miRegion){
			int dx = (nucl->second.x - p->x),  dy = (nucl->second.y - p->y);
			dist = dx*dx + dy*dy;
			if(dist<minima2){
				minima2=dist;
				pReg2=*p;
			}
		}
		
		//PROYECCIÓN
		longitud = ((nucl->first.x - nucl->second.x) * (nucl->first.x - nucl->second.x)) + ((nucl->first.y - nucl->second.y) * (nucl->first.y - nucl->second.y));
		proyeccion = ((pReg.x - pReg2.x) * (pReg.x - pReg2.x)) + ((pReg.y - pReg2.y) * (pReg.y - pReg2.y));
		result = proyeccion/(longitud*1.0);
		//if result <= 0.5 entonces es parada    SINO   es acostada
		cerr<<"longitud: "<<longitud<<" proyeccion: "<<proyeccion<<endl;
		if(result<=0.8)
			parados++;
		
		cerr<</*"puntos: ("<<pReg.x<<","<<pReg.y<<") ("<<pReg2.x<<","<<pReg2.y<<")" <<" longitud = "<<longitud<<" proyeccion = "<< proyeccion<< */" relación = "<<result<<endl;
		//cin.get();
		
		//Teorema del coseno
		/*a = ((pReg.x - nucl->first.x) * (pReg.x - nucl->first.x)) + ((pReg.y - nucl->first.y) * (pReg.y - nucl->first.y));
		b = ((pReg.x - nucl->second.x) * (pReg.x - nucl->second.x)) + ((pReg.y - nucl->second.y) * (pReg.y - nucl->second.y));
		c = ((nucl->first.x - nucl->second.x) * (nucl->first.x - nucl->second.x)) + ((nucl->first.y - nucl->second.y) * (nucl->first.y - nucl->second.y));
		if(a!=0 && b!=0)
			result = acos( ((a*a)+(b*b)-(c*c)) / (2*a*b) ) * 180.0 / PI;
		else
			result = -1111111.0;*/
		
		//PENDIENTES
		//int ma=(nucl->second.y - nucl->first.y) - (nucl->second.x - nucl->first.x);
		//int mb=(pReg.y - nucl->first.y) - (pReg.x - nucl->first.x);
		//double mo= (ma-mb) / (1.0 + ma*mb);
		//double atan(mo);
		
		//cerr<<"distancia: "<<minima<<" angulo: "<<result<<endl; 
	}
	cerr<<"parados: "<<parados<<" acostados: "<<ptosNucleos.size()-parados<<endl;
	if((ptosNucleos.size()-parados) >= parados)
		cerr<<"Tejido Epitelial Plano"<<endl;
	else
		cerr<<"Tejido Epitelial Cilindrico"<<endl;
}
