/***********************************************************************/
/*                                                                     */
/*   Distancias.h                                                      */
/*                                                                     */
/*                                                                     */
/*   Author: Claudia Mazo                                              */
/*   Date: 26.09.13                                                    */
/*                                                                     */
/*   Copyright (c) 2013  Claudia Mazo - All rights reserved            */
/*                                                                     */
/*   This software is available for non-commercial use only. It must   */
/*   not be modified and distributed without prior permission of the   */
/*   author. The author is not responsible for implications from the   */
/*   use of this software.                                             */
/*                                                                     */
/***********************************************************************/

#ifndef DISTANCIAS_H
#define DISTANCIAS_H
#include <cstdlib>
#include <cassert>
#include <iostream>
#include <queue>
#include <list>
#include <sstream>
#include <cmath>
//#include "RegionesGrandes.h"
using namespace std;

#include "CImg.h"
using namespace cimg_library;

#define FOREACH(it, v) for(typeof((v).begin()) it=(v).begin(); it!=(v).end(); ++it)
#define REP(i,n) for(int i=0; i<(int)n; i++)

struct Point {
	int x, y;
	Point(int _x=0, int _y=0) : x(_x), y(_y) {}
	string str() {
		ostringstream ss;
		ss<<"("<<x<<","<<y<<")";
		return ss.str();
	}
};

typedef pair<Point,Point> Celula;

class Distancias
{
	private:
		
	public:
		Distancias(vector< list<Point> >& nucleus, vector< list<Point> >& regions, vector< list<Point> >& epiteliales);
		void mayorDistanciaCelulas(vector< list<Point> >& nucleus, vector< list<Point> > reg, vector< list<Point> >& bordeEpitelial, vector< Celula >& salida);
		bool esEpitelial(list<Point>& nucleo, vector< list<Point> >& regiones);
		void esPlana(vector< Celula >& ptosNucleos, vector< list<Point> > regiones);
};

#endif //DISTANCIAS_H
