/***********************************************************************/
/*                                                                     */
/*  KMeans.h                                                           */
/*                                                                     */
/*                                                                     */
/*   Author: Claudia Mazo                                              */
/*   Date: 26.09.13                                                    */
/*                                                                     */
/*   Copyright (c) 2013  Claudia Mazo - All rights reserved            */
/*                                                                     */
/*   This software is available for non-commercial use only. It must   */
/*   not be modified and distributed without prior permission of the   */
/*   author. The author is not responsible for implications from the   */
/*   use of this software.                                             */
/*                                                                     */
/***********************************************************************/

#ifndef KMEANS_H
#define KMEANS_H

#include <iostream>
#include <vector>
#include "CImg.h"

using namespace std;
using namespace cimg_library;
struct Elemento 
{
	double r,g,s;
	Elemento(double _r=0,double _g=0,double _s=0):r(_r),g(_g),s(_s) {}
};

class KMeans
{
private:	
	const int numCentroidesIniciales;

//private:
	double distancia(const Elemento& elem1, const Elemento& elem2);
	bool iguales(const vector<Elemento> & vec1, const vector<Elemento> & vec2);
	void procesar(CImg<int> &img1, CImg<int> &img2, vector< vector<char> >& etiquetas, vector<Elemento>& centroides);
public:	
	KMeans(const int numCentrIni);
	CImg<int> segmentar(CImg<int> &img1, CImg<int> &img2, const char* n, const char* c, const char* l);
};

struct {int r,g,b;} const color[]= {
	{  0,  0,  0},
	{  0,  0,255},
	{  0,255,  0},
	{  0,255,255},
	{255,  0,  0},
	{255,  0,255},
	{255,255,  0},
	{255,255,255},
	{128,128,128},
};

#endif //KMEANS_H

