/***********************************************************************/
/*                                                                     */
/*   Procesar.cpp                                                      */
/*                                                                     */
/*                                                                     */
/*   Author: Claudia Mazo                                              */
/*   Date: 26.09.13                                                    */
/*                                                                     */
/*   Copyright (c) 2013  Claudia Mazo - All rights reserved            */
/*                                                                     */
/*   This software is available for non-commercial use only. It must   */
/*   not be modified and distributed without prior permission of the   */
/*   author. The author is not responsible for implications from the   */
/*   use of this software.                                             */
/*                                                                     */
/***********************************************************************/

#include "Procesar.h"

Procesar::Procesar():QThread(){

}

void Procesar::inicializar(QString ruta, QString nuevoNomb,QString tis){
    nuevoNombre=nuevoNomb;
    tissue = tis;
    rutaDeImagen = ruta;
}

void Procesar::run(){

    qDebug()<<"hola "<<nuevoNombre<<" "<<tissue;


    CImg<int> original(rutaDeImagen.toStdString().c_str());


    CImg<int> structure(nuevoNombre.toStdString().c_str());
    //string tissue=argv[3];

    vector< list<Point> > bordesCell;
    vector< list<Point> > bordesReg;

    int targetC = 255;
    int replacementC = 100;
    int targetR = 255;
    int replacementR = 100;

    const char* imgNucleo="nucleos.pgm"; //musculo a 10x
    const char* imgConectivo="conectivo.pgm";
    const char* imgLuz="luz.pgm";

     emit(actualizarImagenOriginal());

    KMeans kmeans(3);
    emit(actualizarBarra(20));
    CImg<int> segmentation = kmeans.segmentar(original,structure, imgNucleo, imgConectivo, imgLuz);
    emit(actualizarBarra(30));
    segmentation.save("kmeans.png");
    emit(actualizarBarra(50));
    CImg<int> originalCell(imgNucleo);
    CImg<int> originalReg(imgLuz);
    CImg<int> originalConectivo(imgConectivo);
    //bordes epiteliales
    vector< list<Point> > epiteliales;
    CImg<int> epithelialCells(original.width(), original.height());
    epithelialCells.fill(0);
    //rellenitas epiteliales
    CImg<int> epithelialCellsR(original.width(), original.height());
    epithelialCellsR.fill(0);
    //para globulos rojos
    CImg<int> blueChannel(original.width(), original.height());
    blueChannel.fill(0);
    CImg<int> outThreshold(original.width(), original.height());
    outThreshold.fill(0);
    CImg<int> tmpResult(original.width(), original.height());
    tmpResult.fill(255);
    CImg<int> tmpMuscle(original.width(), original.height());
    CImg<int> tmpRBC(original.width(), original.height());
    CImg<int> residuo(original.width(), original.height());
    residuo.fill(0);
    CImg<int> residuo2(original.width(), original.height());
    residuo2.fill(0);

    DiametroFeret feret;


    if(tissue=="E")
   {
        RegionesGrandes regiones(originalCell, targetC, replacementC, 4500, bordesCell);
        cout<<"cantidad de celulas: "<<bordesCell.size()<<endl;
        RegionesGrandes regiones2(originalReg, targetR, replacementR, 10000, bordesReg);
        cout<<"cantidad de regiones: "<<bordesReg.size()<<endl;
        //Distancias distancias(bordesCell, bordesReg, epiteliales);

        //pintando los bordes de las celulas epiteliales
        FOREACH(e, epiteliales)
                FOREACH(p, *e)
                        epithelialCells(p->x,p->y) = 255;
        epithelialCells.save("epithelialCells.pgm");

        //TODO RELLENAR LOS BORDE PARA CREAR LA ENTRADA DE FERET

        //TODO Creando la img de entrada de feret (fondo negro celulas blancas)
        cimg_forXY(epithelialCells, x, y)
                if( epithelialCells(x,y) == 255 ){
                        list<Point> region;
                        regiones.floodfill(epithelialCells, Point(x,y), region);
                        regiones.pintar(epithelialCellsR, region, 255);
                }
        epithelialCellsR.save("inFeret24.pgm");


        if(feret.isCylindrical())
                cerr<<"Es cubica aqui para con Feret"<<endl;
        else
        {
                cerr<<"Es obalada toca hacer el resto"<<endl;
                //solo deberia llamar a es plana, hacer el llamado a la funcion completa arriba y listo
                Distancias distancias(bordesCell, bordesReg, epiteliales);
        }
        //cout<<"pidio el: "<<tissue<<" que esta temporalmente fuera de servicio"<<endl;
    }

    else if(tissue == "C")
    {
        emit(actualizarBarra(60));
        emit(actualizarBarra(70));
        //cambio para mostrar fondo blanco y tejido en negro, solo por resultados
        cimg_forXY(originalConectivo, x, y)
            if(originalConectivo(x,y)==255)
                    tmpResult(x,y)=0;
        tmpResult.save("CONECTIVOLAXO.pgm");
        //originalConectivo.save("CONECTIVOLAXO.pgm");
        emit(actualizarBarra(80));
        cout<<"pidio el: Conectivo Laxo que esta finalizada"<<endl;
    }
    else
    {
        residuo= (originalCell.erode(3))-originalConectivo;
        //refinar el resultado del muscular eliminado las particulas pequeñas
        RegionesGrandes regiones(residuo, targetR, replacementR, 500, tmpMuscle);
        tmpMuscle.save("MUSCLESINFILTRAR.pgm");

        //**********Globulos Rojos
        cimg_forXY(original, x, y)
                blueChannel(x,y)=original(x,y,2);
        emit(actualizarBarra(60));
        //***************************************************************************************************************
        //UMBRALIZACION
        cimg_forXY(blueChannel, x, y)
                if(blueChannel(x,y)<=130)
                        outThreshold(x,y)=replacementR;
        outThreshold.save("RBC.pgm");
        emit(actualizarBarra(70));
        //***************************************************************************************************************

        //*********Muscle - RBC
        cimg_forXY(tmpMuscle, x, y)
                if(outThreshold(x,y)==0 && tmpMuscle(x,y)!=0)
                        residuo2(x,y)=tmpMuscle(x,y);
        residuo2.save("SINRBC.pgm");
        emit(actualizarBarra(80));

        //Eliminarle residuos de le resta de los RBC
        tmpMuscle.fill(0);
        RegionesGrandes regiones2(residuo2, 128, 255, 100, tmpMuscle);

        //cambio para mostrar fondo blanco y tejido en negro, solo por resultados
        cimg_forXY(tmpMuscle, x, y)
            if(tmpMuscle(x,y)!=0)
                    tmpResult(x,y)=0;
        tmpResult.save("FINALMUSCLE.pgm");

        //tmpMuscle.save("FINALMUSCLE.pgm");
        emit(actualizarBarra(90));


        cout<<"pidio el: Musculo que esta en construcción"<<endl;
    }
    //else
         //cout<<"pidio el: "<<tissue<<" que aun no esta implementado"<<endl;

   emit(actualizarImagenResultado());
   emit(actualizarBarra(100));

}
