/***********************************************************************/
/*                                                                     */
/*   RegionesGrandes.h                                                 */
/*                                                                     */
/*                                                                     */
/*   Author: Claudia Mazo                                              */
/*   Date: 26.09.13                                                    */
/*                                                                     */
/*   Copyright (c) 2013  Claudia Mazo - All rights reserved            */
/*                                                                     */
/*   This software is available for non-commercial use only. It must   */
/*   not be modified and distributed without prior permission of the   */
/*   author. The author is not responsible for implications from the   */
/*   use of this software.                                             */
/*                                                                     */
/***********************************************************************/

#ifndef REGIONESGRANDES_H
#define REGIONESGRANDES_H
#include <cstdlib>
#include <cassert>
#include <iostream>
#include <queue>
#include <list>
#include <sstream>
#include "Distancias.h"
using namespace std;

#include "CImg.h"
using namespace cimg_library;

#define FOREACH(it, v) for(typeof((v).begin()) it=(v).begin(); it!=(v).end(); ++it)
#define REP(i,n) for(int i=0; i<(int)n; i++)

class RegionesGrandes
{
	private:
		CImg<int> image;
		CImg<int> original;
		int replace;
		int target;
		
	public:
		RegionesGrandes(CImg<int> img, int tar, int repl, int size, vector< list<Point> >& salida);
		RegionesGrandes(CImg<int> img, int tar, int rep, int size, CImg<int>& out);
		bool valid(const CImg<int>& img, int x, int y);
		void floodfill(CImg<int>& img, Point inicio, list<Point>& salida);
		void pintar(CImg<int>& img, const list<Point>& puntos, int color);
        void extraerBordes(const CImg<int>& img, const list<Point>& puntos, list<Point>& salida);
};

#endif //REGIONESGRANDES_H

