/***********************************************************************/
/*                                                                     */
/*   mainwindow.cpp                                                    */
/*                                                                     */
/*                                                                     */
/*   Author: Claudia Mazo                                              */
/*   Date: 26.09.13                                                    */
/*                                                                     */
/*   Copyright (c) 2013  Claudia Mazo - All rights reserved            */
/*                                                                     */
/*   This software is available for non-commercial use only. It must   */
/*   not be modified and distributed without prior permission of the   */
/*   author. The author is not responsible for implications from the   */
/*   use of this software.                                             */
/*                                                                     */
/***********************************************************************/

#include "mainwindow.h"
#include "ui_mainwindow.h"


MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);

    miProceso = new Procesar();

    connect(miProceso, SIGNAL(actualizarImagenOriginal()), this, SLOT(actualizarImgOriginal()));
    connect(miProceso, SIGNAL(actualizarImagenResultado()), this, SLOT(actualizarImgResult()));
    connect(miProceso, SIGNAL(actualizarBarra(int)), this, SLOT(actualizarBarra(int)));

}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::on_btn_examinar_clicked()
{
    rutaDeImagen = QFileDialog::getOpenFileName(this,"Archivos", "/home","Images (*.png *.xpm *.jpg)");
    ui->txt_archivo->setText(rutaDeImagen);

}

void MainWindow::on_btn_procesar_clicked()
{
    ui->progressBar->setValue(0);
    QPixmap pix(rutaDeImagen);
    int w = ui->lbl_original->width();
    int h = ui->lbl_original->height();

    // set a scaled pixmap to a w x h window keeping its aspect ratio
    ui->lbl_original->setPixmap(pix.scaled(w,h,Qt::KeepAspectRatio));
    ui->progressBar->setValue(10);

    ui->lbl_info->setText("Hematoxilina-Eosina     10X");
   //ui->lbl_original->repaint();
    //repaint();


    //la imagen de salida del structure maximun eigenvalue

    QFileInfo * nombre = new QFileInfo(rutaDeImagen);
    QString nuevoNombre = nombre->absolutePath() + "/" + nombre->baseName() + "S."+nombre->completeSuffix();
    //qDebug() << nuevoNombre;

    //procesar(nuevoNombre);

    tejido = "";
    if (ui->rbt_conectivo->isChecked())
        tejido="C";
    else
        tejido="M";

    miProceso->inicializar(rutaDeImagen, nuevoNombre, tejido);

    miProceso->start();

}

void MainWindow::actualizarImgOriginal(){
    QPixmap pix("limpiar.png");
    int w = ui->lbl_original->width();
    int h = ui->lbl_original->height();
    ////////////////////////////////////////////////////////////////////////////////////////ui->progressBar->setValue(60);
    // set a scaled pixmap to a w x h window keeping its aspect ratio
    ui->lbl_original->setPixmap(pix.scaled(w,h,Qt::KeepAspectRatio));
    ui->lbl_result->setPixmap(pix.scaled(w,h,Qt::KeepAspectRatio));

    QPixmap pixO(rutaDeImagen);
    ui->lbl_original->setPixmap(pixO.scaled(w,h,Qt::KeepAspectRatio));
}

void MainWindow::actualizarImgResult(){

    if(tejido=="C"){
        QPixmap pix("CONECTIVOLAXO.pgm");
        int w = ui->lbl_original->width();
        int h = ui->lbl_original->height();

        // set a scaled pixmap to a w x h window keeping its aspect ratio
        ui->lbl_result->setPixmap(pix.scaled(w,h,Qt::KeepAspectRatio));
    }
    else{
        QPixmap pix("FINALMUSCLE.pgm");
        int w = ui->lbl_original->width();
        int h = ui->lbl_original->height();

        // set a scaled pixmap to a w x h window keeping its aspect ratio
        ui->lbl_result->setPixmap(pix.scaled(w,h,Qt::KeepAspectRatio));
    }


}

void MainWindow::actualizarBarra(int i){
    ui->progressBar->setValue(i);
}

void MainWindow::on_rbt_conectivo_toggled(bool checked)
{

}
