/***********************************************************************/
/*                                                                     */
/*   mainwindow.h                                                      */
/*                                                                     */
/*                                                                     */
/*   Author: Claudia Mazo                                              */
/*   Date: 26.09.13                                                    */
/*                                                                     */
/*   Copyright (c) 2013  Claudia Mazo - All rights reserved            */
/*                                                                     */
/*   This software is available for non-commercial use only. It must   */
/*   not be modified and distributed without prior permission of the   */
/*   author. The author is not responsible for implications from the   */
/*   use of this software.                                             */
/*                                                                     */
/***********************************************************************/

#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QtGui>
#include <QDebug>
#include "RegionesGrandes.h"
#include "Distancias.h"
#include "KMeans.h"
#include "DiametroFeret.h"
#include "Procesar.h"

namespace Ui {
    class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();

private slots:
    void on_btn_examinar_clicked();

    void on_btn_procesar_clicked();

    void on_rbt_conectivo_toggled(bool checked);

    void actualizarImgOriginal();
    void actualizarImgResult();
    //void limpiarResult();
    void actualizarBarra(int i);

signals:


private:
    Ui::MainWindow *ui;
    QString rutaDeImagen;
    QString nombreImagen;
    QString tejido;
    Procesar* miProceso;

};

#endif // MAINWINDOW_H
